# -*- coding: utf-8 -*-
"""
Created on Wed Jul  8 22:53:55 2020

@author: AWA
"""

import time

import serial

ESSPowerSupply = serial.Serial()
ESSPowerSupply.baudrate = 9600
ESSPowerSupply.port = "COM36"  # replace com1 with the actual serial port
# COM36 is PortServer TS16 MEI#2 - port 10

# S*Vdddd=Set scaling voltage to dddd Volts
# S*Cdddd=Set Scaling current to dddd Amps
# ?M returns mode, SN, etc
# SR put the supply in REMOTE operating mode
# PC%## to set the current output to ##% of full scale
# PV%## to set the voltage output to ##% of full scale
# MV measure the voltage output
# MC measure the current output


def Connect():
    if ESSPowerSupply.is_open:
        ESSPowerSupply.close()
    ESSPowerSupply.open()
    return


def Disconnect():
    ESSPowerSupply.close()
    return


def PowerOff():
    ESSPowerSupply.write("PC%00\r\n".encode("utf-8"))
    ESSPowerSupply.write("PV%00\r\n".encode("utf-8"))
    return


def Initialize():
    Connect()
    ESSPowerSupply.write("SR\r\n".encode("utf-8"))
    time.sleep(1)
    ESSPowerSupply.write("S*V0030\r\n".encode("utf-8"))
    time.sleep(1)
    ESSPowerSupply.write("S*C0500\r\n".encode("utf-8"))
    time.sleep(1)
    ESSPowerSupply.write("PC%00\r\n".encode("utf-8"))
    time.sleep(1)
    ESSPowerSupply.write("PV%99\r\n".encode("utf-8"))
    a = ESSPowerSupply.read_all()
    return


def SetCurrent(I):
    pc = int(I / 500.0 * 1000)
    cmd = ("PC%" + "{}".format(pc).zfill(3) + "\r\n").encode("utf-8")
    ESSPowerSupply.write(cmd)
    a = ESSPowerSupply.read_all()
    return


def MeasureCurrent():
    cmd = ("MC\r\n").encode("utf-8")
    ESSPowerSupply.write(cmd)
    time.sleep(1)
    a = ESSPowerSupply.read_all()
    return a


Initialize()
##time.sleep(1)
##SetCurrent(50)
##time.sleep(1)
##MeasureCurrent()
