# csstudio_panelbuilder

A set of python script to generate CSStudio panel from a set of AWA EPICS devices and save/restore values 

## PanelBuilder.py
usage:
```bash
python PanelBuilder.py inputMagnet.txt ouputPanelName.bob 
```
will take the configuration file save in inputMagnet.txt and produce the CSstudio input file ouputPanelName.bob that can be opened as a panel. 

Prepare an input file with the device you want to appear in the control panel. Each line should be as follow:
```bash
device_name epics_channel_readback_name epics_channel_control_name 
```
where
- device name: is an abstriraty string (no space allowed) that describe the device, e.g., Quad_BlueINP_1 
- epics_channel_readback_name is the readback channel, e.g., AWA:Drive:DT8V_B_S:RB
- epics_channel_controlkname is the control channel, e.g., AWA:Drive:DT8V_B_S:RB

 
For example, the line to control DT12 would be 

```bash
Trim_1_V AWA:Drive:DT8V_B_S:RB AWA:Drive:DT8V_B_S:Ctrl

```

The scripts allows you to iclude comment as follows:
```bash
my_comment_here comment comment 
```
where the 2nd and 3rd line have the chain string "comment" 
for instance
```bash
triplet_blue_INP_start comment comment
```

## SaveRestore.py
