import socket
import time


def SetTDC(steps, command="MT", index=0, address="192.168.0.153", verbose=False):
    """
    backlash not implemented
    MT: move to position
    MO: move by relative step
    """
    assert command in ["R", "PD", "PU", "LU", "LD", "MT", "MO"]
    AWABeamlineClient = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    if command in ["MO", "MT"]:
        cmd = f"{command} {index} {int(steps)}"
    else:
        cmd = f"{command} {index}"
    AWABeamlineClient.connect((address, 8080))

    cmd += " \n"
    if verbose:
        print(cmd)
    AWABeamlineClient.send(cmd.encode())
    if command == "R":
        data = AWABeamlineClient.recv(512)
        AWABeamlineClient.close()
        return data
    else:
        AWABeamlineClient.close()


def SetMagnets(counts, channels, beamline="Drive", verbose=False):
    # beamline: Drive | Witness | ACT | EEX
    # settings: [[chindex, counts],.....]
    # counts = np.divide(gradients , cals)
    assert len(counts) == len(channels)
    settings = []
    for i in range(len(counts)):
        settings.append([channels[i], int(counts[i])])
    if verbose:
        print(repr(settings))
    AWABeamlineClient = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    cmd = f"GroupSet {beamline} {len(counts)} "
    AWABeamlineClient.connect(("192.168.0.9", 80))
    for j in range(len(counts)):
        cmd += " { " + "{} {} ".format(settings[j][0], settings[j][1])
        cmd += "} "
    cmd += " \n"
    # print(cmd)
    AWABeamlineClient.send(cmd.encode())
    data = AWABeamlineClient.recv(512)
    AWABeamlineClient.close()
    # print(data)
