# -*- coding: utf-8 -*-
"""
Created on Fri Aug 26 14:13:25 2022

@author: awa
"""

import matplotlib.pyplot as plt
import numpy as np
from scipy.optimize import curve_fit


def func(x, a, b, c, d):
    return a * np.sin(b * x + c) + d


xdata = PhaseShifter
ydata = CentroidY
xdata_n = np.linspace(xdata.min(), xdata.max())
p0 = [
    (ydata.max() - ydata.min()) / 2,
    np.pi * 4 / (xdata.max() - xdata.min()),
    0,
    ydata.mean(),
]
popt, pcov = curve_fit(func, xdata, ydata, p0=p0)

a, b, c, d = popt
print(popt)
print(f"{a}*sin({b}*x+{c})+{d}")
print(f"a : {a}")
print(f"b : {b}")
print(f"c : {c}")
print(f"d : {d}")
plt.plot(xdata, ydata, "o", label="data")
plt.plot(xdata_n, func(xdata_n, *popt), label="fit")
plt.grid()
plt.legend()
plt.show()
